import { Injectable } from '@angular/core';
import {
  HttpRequest,
  HttpHandler,
  HttpEvent,
  HttpInterceptor,
  HttpResponse
} from '@angular/common/http';
import { Observable, of } from 'rxjs'
const mockdata = [
    {
      "healthIndex": 85,
      "endDate": null,
      "minValueDateTime": 1514844000,
      "type": "systemHealth",
      "cowId": 636,
      "animalId": "624",
      "eventId": 34720,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 92,
      "ageInDays": 2101,
      "startDateTime": 1514844000,
      "reportingDateTime": 1514844938
    },
    {
      "healthIndex": 85,
      "endDate": null,
      "minValueDateTime": 1514844000,
      "type": "systemHealth",
      "cowId": 809,
      "animalId": "871",
      "eventId": 34719,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 357,
      "ageInDays": 1075,
      "startDateTime": 1514844000,
      "reportingDateTime": 1514844929
    },
    {
      "alertType": "preCalving",
      "duration": 990,
      "originalStartDateTime": null,
      "endDateTime": null,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 910,
      "animalId": "961",
      "eventId": 34718,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 770,
      "ageInDays": 770,
      "startDateTime": 1514842797,
      "reportingDateTime": 1514844259
    },
    {
      "healthIndex": 77,
      "endDate": null,
      "minValueDateTime": 1514840400,
      "type": "systemHealth",
      "cowId": 910,
      "animalId": "961",
      "eventId": 34716,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 770,
      "ageInDays": 770,
      "startDateTime": 1514836800,
      "reportingDateTime": 1514843103
    },
    {
      "alertType": "moderatePreCalving",
      "duration": 720,
      "originalStartDateTime": null,
      "endDateTime": 1514829642,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 910,
      "animalId": "961",
      "eventId": 34715,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 770,
      "ageInDays": 770,
      "startDateTime": 1514827932,
      "reportingDateTime": 1514829724
    },
    {
      "heatIndexPeak": "92",
      "type": "systemHeat",
      "cowId": 728,
      "animalId": "767",
      "eventId": 34717,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 33,
      "ageInDays": 1468,
      "startDateTime": 1514800800,
      "reportingDateTime": 1514844320
    },
    {
      "newGroupId": 46,
      "newGroupName": "Suckling Calves",
      "currentGroupId": 0,
      "currentGroupName": null,
      "type": "changeGroup",
      "cowId": 1228,
      "animalId": "369",
      "eventId": 34702,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 0,
      "ageInDays": 0,
      "startDateTime": 1514791201,
      "reportingDateTime": 1514813089
    },
    {
      "destinationGroup": 57,
      "destinationGroupName": "Low",
      "calvingEase": null,
      "daysInPregnancy": 271,
      "oldLactationNumber": 1,
      "newborns": null,
      "type": "calving",
      "cowId": 819,
      "animalId": "881",
      "eventId": 34712,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 0,
      "ageInDays": 1044,
      "startDateTime": 1514791200,
      "reportingDateTime": 1514813117
    },
    {
      "destinationGroup": 0,
      "destinationGroupName": null,
      "cowEntryStatus": "Heifer",
      "type": "herdEntry",
      "cowId": 1228,
      "animalId": "369",
      "eventId": 34703,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 0,
      "ageInDays": 0,
      "startDateTime": 1514791200,
      "reportingDateTime": 1514813089
    },
    {
      "birthDateCalculated": false,
      "type": "birth",
      "cowId": 1228,
      "animalId": "369",
      "eventId": 34701,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 0,
      "ageInDays": 0,
      "startDateTime": 1514791200,
      "reportingDateTime": 1514813088
    },
    {
      "sire": null,
      "breedingNumber": 2,
      "isOutOfBreedingWindow": false,
      "interval": 15,
      "type": "breeding",
      "cowId": 1004,
      "animalId": "149",
      "eventId": 34710,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 548,
      "ageInDays": 548,
      "startDateTime": 1514781900,
      "reportingDateTime": 1514813113
    },
    {
      "sire": null,
      "breedingNumber": 3,
      "isOutOfBreedingWindow": false,
      "interval": 3,
      "type": "breeding",
      "cowId": 699,
      "animalId": "725",
      "eventId": 34709,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 120,
      "ageInDays": 1651,
      "startDateTime": 1514781900,
      "reportingDateTime": 1514813109
    },
    {
      "sire": null,
      "breedingNumber": 2,
      "isOutOfBreedingWindow": false,
      "interval": 18,
      "type": "breeding",
      "cowId": 845,
      "animalId": "1489",
      "eventId": 34708,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 111,
      "ageInDays": 1741,
      "startDateTime": 1514781900,
      "reportingDateTime": 1514813106
    },
    {
      "sire": null,
      "breedingNumber": 12,
      "isOutOfBreedingWindow": false,
      "interval": 26,
      "type": "breeding",
      "cowId": 730,
      "animalId": "769",
      "eventId": 34707,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 365,
      "ageInDays": 1462,
      "startDateTime": 1514781900,
      "reportingDateTime": 1514813103
    },
    {
      "sire": null,
      "breedingNumber": 13,
      "isOutOfBreedingWindow": false,
      "interval": 20,
      "type": "breeding",
      "cowId": 738,
      "animalId": "780",
      "eventId": 34706,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 321,
      "ageInDays": 1424,
      "startDateTime": 1514781900,
      "reportingDateTime": 1514813099
    },
    {
      "sire": null,
      "breedingNumber": 2,
      "isOutOfBreedingWindow": false,
      "interval": 15,
      "type": "breeding",
      "cowId": 636,
      "animalId": "624",
      "eventId": 34705,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 91,
      "ageInDays": 2100,
      "startDateTime": 1514781900,
      "reportingDateTime": 1514813097
    },
    {
      "heatIndexPeak": "98",
      "type": "systemHeat",
      "cowId": 730,
      "animalId": "769",
      "eventId": 34714,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 365,
      "ageInDays": 1462,
      "startDateTime": 1514779200,
      "reportingDateTime": 1514841344
    },
    {
      "heatIndexPeak": "99",
      "type": "systemHeat",
      "cowId": 738,
      "animalId": "780",
      "eventId": 34713,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 321,
      "ageInDays": 1424,
      "startDateTime": 1514775600,
      "reportingDateTime": 1514813125
    },
    {
      "heatIndexPeak": "87",
      "type": "systemHeat",
      "cowId": 699,
      "animalId": "725",
      "eventId": 34700,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 120,
      "ageInDays": 1651,
      "startDateTime": 1514772000,
      "reportingDateTime": 1514809528
    },
    {
      "heatIndexPeak": "96",
      "type": "systemHeat",
      "cowId": 845,
      "animalId": "1489",
      "eventId": 34699,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 111,
      "ageInDays": 1741,
      "startDateTime": 1514764800,
      "reportingDateTime": 1514844953
    },
    {
      "healthIndex": 57,
      "endDate": null,
      "minValueDateTime": 1514808000,
      "type": "systemHealth",
      "cowId": 926,
      "animalId": "977",
      "eventId": 34694,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 8,
      "ageInDays": 725,
      "startDateTime": 1514761200,
      "reportingDateTime": 1514810703
    },
    {
      "newGroupId": 57,
      "newGroupName": "Low",
      "currentGroupId": 60,
      "currentGroupName": "Calving Preparation",
      "type": "changeGroup",
      "cowId": 819,
      "animalId": "881",
      "eventId": 34704,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 351,
      "ageInDays": 1044,
      "startDateTime": 1514757600,
      "reportingDateTime": 1514813095
    },
    {
      "heatIndexPeak": "87",
      "type": "systemHeat",
      "cowId": 589,
      "animalId": "483",
      "eventId": 34698,
      "deletable": false,
      "lactationNumber": 5,
      "daysInLactation": 395,
      "ageInDays": 2688,
      "startDateTime": 1514746800,
      "reportingDateTime": 1514784320
    },
    {
      "alertType": "distress",
      "duration": 1250,
      "originalStartDateTime": null,
      "endDateTime": 1514770647,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 977,
      "animalId": "127",
      "eventId": 34674,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 616,
      "ageInDays": 616,
      "startDateTime": 1514743706,
      "reportingDateTime": 1514770923
    },
    {
      "heatIndexPeak": "95",
      "type": "systemHeat",
      "cowId": 709,
      "animalId": "738",
      "eventId": 34697,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 51,
      "ageInDays": 1578,
      "startDateTime": 1514736000,
      "reportingDateTime": 1514772324
    },
    {
      "heatIndexPeak": "91",
      "type": "systemHeat",
      "cowId": 636,
      "animalId": "624",
      "eventId": 34695,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 90,
      "ageInDays": 2099,
      "startDateTime": 1514732400,
      "reportingDateTime": 1514768779
    },
    {
      "heatIndexPeak": "65",
      "type": "systemHeat",
      "cowId": 1004,
      "animalId": "149",
      "eventId": 34696,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 547,
      "ageInDays": 547,
      "startDateTime": 1514728800,
      "reportingDateTime": 1514768799
    },
    {
      "heatIndexPeak": "99",
      "type": "systemHeat",
      "cowId": 1022,
      "animalId": "170",
      "eventId": 34693,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 466,
      "ageInDays": 466,
      "startDateTime": 1514714400,
      "reportingDateTime": 1514822722
    },
    {
      "sire": null,
      "breedingNumber": 3,
      "isOutOfBreedingWindow": true,
      "interval": 50,
      "type": "breeding",
      "cowId": 888,
      "animalId": "938",
      "eventId": 34692,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 179,
      "ageInDays": 836,
      "startDateTime": 1514695500,
      "reportingDateTime": 1514749023
    },
    {
      "sire": null,
      "breedingNumber": 14,
      "isOutOfBreedingWindow": false,
      "interval": 23,
      "type": "breeding",
      "cowId": 790,
      "animalId": "846",
      "eventId": 34691,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 534,
      "ageInDays": 1190,
      "startDateTime": 1514695500,
      "reportingDateTime": 1514749021
    },
    {
      "heatIndexPeak": "98",
      "type": "systemHeat",
      "cowId": 662,
      "animalId": "669",
      "eventId": 34673,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 53,
      "ageInDays": 1848,
      "startDateTime": 1514692800,
      "reportingDateTime": 1514802323
    },
    {
      "heatIndexPeak": "99",
      "type": "systemHeat",
      "cowId": 653,
      "animalId": "656",
      "eventId": 34672,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 396,
      "ageInDays": 1894,
      "startDateTime": 1514682000,
      "reportingDateTime": 1514791519
    },
    {
      "newGroupId": 62,
      "newGroupName": "Dry",
      "currentGroupId": 58,
      "currentGroupName": "Young",
      "type": "changeGroup",
      "cowId": 854,
      "animalId": "900",
      "eventId": 34684,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 300,
      "ageInDays": 978,
      "startDateTime": 1514671201,
      "reportingDateTime": 1514749014
    },
    {
      "newGroupId": 62,
      "newGroupName": "Dry",
      "currentGroupId": 56,
      "currentGroupName": "High",
      "type": "changeGroup",
      "cowId": 670,
      "animalId": "678",
      "eventId": 34682,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 338,
      "ageInDays": 1803,
      "startDateTime": 1514671201,
      "reportingDateTime": 1514749011
    },
    {
      "newGroupId": 62,
      "newGroupName": "Dry",
      "currentGroupId": 59,
      "currentGroupName": "1st Lactation",
      "type": "changeGroup",
      "cowId": 801,
      "animalId": "861",
      "eventId": 34680,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 361,
      "ageInDays": 1099,
      "startDateTime": 1514671201,
      "reportingDateTime": 1514749009
    },
    {
      "newGroupId": 41,
      "newGroupName": "Weaned Heifers",
      "currentGroupId": 46,
      "currentGroupName": "Suckling Calves",
      "type": "changeGroup",
      "cowId": 1197,
      "animalId": "339",
      "eventId": 34690,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 60,
      "ageInDays": 60,
      "startDateTime": 1514671200,
      "reportingDateTime": 1514749020
    },
    {
      "newGroupId": 41,
      "newGroupName": "Weaned Heifers",
      "currentGroupId": 46,
      "currentGroupName": "Suckling Calves",
      "type": "changeGroup",
      "cowId": 1199,
      "animalId": "340",
      "eventId": 34689,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 55,
      "ageInDays": 55,
      "startDateTime": 1514671200,
      "reportingDateTime": 1514749018
    },
    {
      "newGroupId": 41,
      "newGroupName": "Weaned Heifers",
      "currentGroupId": 46,
      "currentGroupName": "Suckling Calves",
      "type": "changeGroup",
      "cowId": 1198,
      "animalId": "7418",
      "eventId": 34688,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 56,
      "ageInDays": 56,
      "startDateTime": 1514671200,
      "reportingDateTime": 1514749017
    },
    {
      "destinationGroup": 62,
      "destinationGroupName": "Dry",
      "daysInPregnancy": 204,
      "type": "dryOff",
      "cowId": 854,
      "animalId": "900",
      "eventId": 34685,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 300,
      "ageInDays": 978,
      "startDateTime": 1514671200,
      "reportingDateTime": 1514749014
    },
    {
      "destinationGroup": 62,
      "destinationGroupName": "Dry",
      "daysInPregnancy": 211,
      "type": "dryOff",
      "cowId": 670,
      "animalId": "678",
      "eventId": 34683,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 338,
      "ageInDays": 1803,
      "startDateTime": 1514671200,
      "reportingDateTime": 1514749011
    },
    {
      "destinationGroup": 62,
      "destinationGroupName": "Dry",
      "daysInPregnancy": 207,
      "type": "dryOff",
      "cowId": 801,
      "animalId": "861",
      "eventId": 34681,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 361,
      "ageInDays": 1099,
      "startDateTime": 1514671200,
      "reportingDateTime": 1514749009
    },
    {
      "alertType": "distress",
      "duration": 920,
      "originalStartDateTime": null,
      "endDateTime": 1514670301,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 755,
      "animalId": "805",
      "eventId": 34666,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 118,
      "ageInDays": 1342,
      "startDateTime": 1514664301,
      "reportingDateTime": 1514670723
    },
    {
      "alertType": "distress",
      "duration": 1040,
      "originalStartDateTime": null,
      "endDateTime": 1514662936,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 755,
      "animalId": "805",
      "eventId": 34664,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 118,
      "ageInDays": 1342,
      "startDateTime": 1514657401,
      "reportingDateTime": 1514663523
    },
    {
      "heatIndexPeak": "95",
      "type": "systemHeat",
      "cowId": 712,
      "animalId": "742",
      "eventId": 34671,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 902,
      "ageInDays": 1559,
      "startDateTime": 1514656800,
      "reportingDateTime": 1514763315
    },
    {
      "heatIndexPeak": "91",
      "type": "systemHeat",
      "cowId": 626,
      "animalId": "594",
      "eventId": 34670,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 225,
      "ageInDays": 2210,
      "startDateTime": 1514653200,
      "reportingDateTime": 1514689524
    },
    {
      "heatIndexPeak": "99",
      "type": "systemHeat",
      "cowId": 790,
      "animalId": "846",
      "eventId": 34667,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 533,
      "ageInDays": 1189,
      "startDateTime": 1514646000,
      "reportingDateTime": 1514743529
    },
    {
      "alertType": "distress",
      "duration": 1360,
      "originalStartDateTime": null,
      "endDateTime": 1514646376,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 755,
      "animalId": "805",
      "eventId": 34663,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 118,
      "ageInDays": 1342,
      "startDateTime": 1514642896,
      "reportingDateTime": 1514646723
    },
    {
      "heatIndexPeak": "59",
      "type": "systemHeat",
      "cowId": 958,
      "animalId": "504",
      "eventId": 34669,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 137,
      "ageInDays": 1232,
      "startDateTime": 1514642400,
      "reportingDateTime": 1514682403
    },
    {
      "heatIndexPeak": "85",
      "type": "systemHeat",
      "cowId": 799,
      "animalId": "857",
      "eventId": 34668,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 33,
      "ageInDays": 1117,
      "startDateTime": 1514642400,
      "reportingDateTime": 1514752510
    },
    {
      "alertType": "distress",
      "duration": 1320,
      "originalStartDateTime": null,
      "endDateTime": 1514730761,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 977,
      "animalId": "127",
      "eventId": 34662,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 615,
      "ageInDays": 615,
      "startDateTime": 1514635646,
      "reportingDateTime": 1514731323
    },
    {
      "heatIndexPeak": "93",
      "type": "systemHeat",
      "cowId": 652,
      "animalId": "654",
      "eventId": 34665,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 441,
      "ageInDays": 1897,
      "startDateTime": 1514624400,
      "reportingDateTime": 1514733339
    },
    {
      "alertType": "distress",
      "duration": 860,
      "originalStartDateTime": null,
      "endDateTime": 1514630876,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 977,
      "animalId": "127",
      "eventId": 34661,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 615,
      "ageInDays": 615,
      "startDateTime": 1514622866,
      "reportingDateTime": 1514631124
    },
    {
      "alertType": "distress",
      "duration": 1390,
      "originalStartDateTime": null,
      "endDateTime": 1514635141,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 755,
      "animalId": "805",
      "eventId": 34660,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 118,
      "ageInDays": 1342,
      "startDateTime": 1514620725,
      "reportingDateTime": 1514635323
    },
    {
      "alertType": "distress",
      "duration": 1320,
      "originalStartDateTime": null,
      "endDateTime": 1514615205,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 755,
      "animalId": "805",
      "eventId": 34639,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 118,
      "ageInDays": 1342,
      "startDateTime": 1514614005,
      "reportingDateTime": 1514615523
    },
    {
      "healthIndex": 54,
      "endDate": 1514829600,
      "minValueDateTime": 1514678400,
      "type": "systemHealth",
      "cowId": 977,
      "animalId": "127",
      "eventId": 34638,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 615,
      "ageInDays": 615,
      "startDateTime": 1514599200,
      "reportingDateTime": 1514830528
    },
    {
      "alertType": "distress",
      "duration": 1380,
      "originalStartDateTime": null,
      "endDateTime": 1514611605,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 755,
      "animalId": "805",
      "eventId": 34635,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 117,
      "ageInDays": 1341,
      "startDateTime": 1514571495,
      "reportingDateTime": 1514611923
    },
    {
      "healthIndex": 74,
      "endDate": 1514743200,
      "minValueDateTime": 1514584800,
      "type": "systemHealth",
      "cowId": 755,
      "animalId": "805",
      "eventId": 34636,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 117,
      "ageInDays": 1341,
      "startDateTime": 1514570400,
      "reportingDateTime": 1514745304
    },
    {
      "healthIndex": 65,
      "endDate": 1514646000,
      "minValueDateTime": 1514595600,
      "type": "systemHealth",
      "cowId": 847,
      "animalId": "892",
      "eventId": 34633,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 311,
      "ageInDays": 1010,
      "startDateTime": 1514552400,
      "reportingDateTime": 1514647512
    },
    {
      "heatIndexPeak": "94",
      "type": "systemHeat",
      "cowId": 888,
      "animalId": "938",
      "eventId": 34637,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 177,
      "ageInDays": 834,
      "startDateTime": 1514534400,
      "reportingDateTime": 1514625934
    },
    {
      "sire": null,
      "breedingNumber": 1,
      "isOutOfBreedingWindow": false,
      "interval": null,
      "type": "breeding",
      "cowId": 592,
      "animalId": "526",
      "eventId": 34659,
      "deletable": false,
      "lactationNumber": 5,
      "daysInLactation": 77,
      "ageInDays": 2535,
      "startDateTime": 1514522700,
      "reportingDateTime": 1514620386
    },
    {
      "sire": null,
      "breedingNumber": 2,
      "isOutOfBreedingWindow": false,
      "interval": 21,
      "type": "breeding",
      "cowId": 699,
      "animalId": "725",
      "eventId": 34658,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 117,
      "ageInDays": 1648,
      "startDateTime": 1514522700,
      "reportingDateTime": 1514620384
    },
    {
      "sire": null,
      "breedingNumber": 2,
      "isOutOfBreedingWindow": false,
      "interval": 63,
      "type": "breeding",
      "cowId": 635,
      "animalId": "623",
      "eventId": 34657,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 129,
      "ageInDays": 2105,
      "startDateTime": 1514522700,
      "reportingDateTime": 1514620382
    },
    {
      "sire": null,
      "breedingNumber": 3,
      "isOutOfBreedingWindow": false,
      "interval": 18,
      "type": "breeding",
      "cowId": 779,
      "animalId": "829",
      "eventId": 34656,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 116,
      "ageInDays": 1238,
      "startDateTime": 1514522700,
      "reportingDateTime": 1514620380
    },
    {
      "heatIndexPeak": "91",
      "type": "systemHeat",
      "cowId": 635,
      "animalId": "623",
      "eventId": 34634,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 129,
      "ageInDays": 2105,
      "startDateTime": 1514516400,
      "reportingDateTime": 1514554506
    },
    {
      "heatIndexPeak": "94",
      "type": "systemHeat",
      "cowId": 779,
      "animalId": "829",
      "eventId": 34632,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 116,
      "ageInDays": 1238,
      "startDateTime": 1514516400,
      "reportingDateTime": 1514553333
    },
    {
      "heatIndexPeak": "85",
      "type": "systemHeat",
      "cowId": 725,
      "animalId": "762",
      "eventId": 34631,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 1,
      "ageInDays": 1489,
      "startDateTime": 1514516400,
      "reportingDateTime": 1514749003
    },
    {
      "healthIndex": 85,
      "endDate": 1514530800,
      "minValueDateTime": 1514505600,
      "type": "systemHealth",
      "cowId": 914,
      "animalId": "965",
      "eventId": 34629,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 5,
      "ageInDays": 752,
      "startDateTime": 1514505600,
      "reportingDateTime": 1514533504
    },
    {
      "heatIndexPeak": "99",
      "type": "systemHeat",
      "cowId": 621,
      "animalId": "587",
      "eventId": 34630,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 313,
      "ageInDays": 2244,
      "startDateTime": 1514473200,
      "reportingDateTime": 1514509575
    },
    {
      "destinationGroup": 57,
      "destinationGroupName": "Low",
      "calvingEase": null,
      "daysInPregnancy": 277,
      "oldLactationNumber": 2,
      "newborns": null,
      "type": "calving",
      "cowId": 725,
      "animalId": "762",
      "eventId": 34677,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 0,
      "ageInDays": 1488,
      "startDateTime": 1514463600,
      "reportingDateTime": 1514749003
    },
    {
      "heatIndexPeak": "87",
      "type": "systemHeat",
      "cowId": 699,
      "animalId": "725",
      "eventId": 34628,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 116,
      "ageInDays": 1647,
      "startDateTime": 1514462400,
      "reportingDateTime": 1514499345
    },
    {
      "heatIndexPeak": "97",
      "type": "systemHeat",
      "cowId": 592,
      "animalId": "526",
      "eventId": 34627,
      "deletable": false,
      "lactationNumber": 5,
      "daysInLactation": 76,
      "ageInDays": 2534,
      "startDateTime": 1514462400,
      "reportingDateTime": 1514499341
    },
    {
      "sire": null,
      "breedingNumber": 2,
      "isOutOfBreedingWindow": false,
      "interval": 22,
      "type": "breeding",
      "cowId": 640,
      "animalId": "635",
      "eventId": 34655,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 87,
      "ageInDays": 2020,
      "startDateTime": 1514436300,
      "reportingDateTime": 1514620378
    },
    {
      "destinationGroup": 59,
      "destinationGroupName": "1st Lactation",
      "calvingEase": null,
      "daysInPregnancy": 294,
      "oldLactationNumber": 0,
      "newborns": null,
      "type": "calving",
      "cowId": 903,
      "animalId": "954",
      "eventId": 34654,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 0,
      "ageInDays": 808,
      "startDateTime": 1514436000,
      "reportingDateTime": 1514620375
    },
    {
      "heatIndexPeak": "99",
      "type": "systemHeat",
      "cowId": 669,
      "animalId": "677",
      "eventId": 34626,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 695,
      "ageInDays": 1817,
      "startDateTime": 1514433600,
      "reportingDateTime": 1514542539
    },
    {
      "heatIndexPeak": "63",
      "type": "systemHeat",
      "cowId": 943,
      "animalId": "994",
      "eventId": 34625,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 687,
      "ageInDays": 687,
      "startDateTime": 1514426400,
      "reportingDateTime": 1514534720
    },
    {
      "heatIndexPeak": "86",
      "type": "systemHeat",
      "cowId": 931,
      "animalId": "982",
      "eventId": 34624,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 0,
      "ageInDays": 709,
      "startDateTime": 1514426400,
      "reportingDateTime": 1514620372
    },
    {
      "destinationGroup": 58,
      "destinationGroupName": "Young",
      "calvingEase": null,
      "daysInPregnancy": 275,
      "oldLactationNumber": 0,
      "newborns": null,
      "type": "calving",
      "cowId": 931,
      "animalId": "982",
      "eventId": 34652,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 0,
      "ageInDays": 709,
      "startDateTime": 1514421000,
      "reportingDateTime": 1514620372
    },
    {
      "newGroupId": 46,
      "newGroupName": "Suckling Calves",
      "currentGroupId": 0,
      "currentGroupName": null,
      "type": "changeGroup",
      "cowId": 1227,
      "animalId": "368",
      "eventId": 34641,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 0,
      "ageInDays": 0,
      "startDateTime": 1514419201,
      "reportingDateTime": 1514620354
    },
    {
      "destinationGroup": 59,
      "destinationGroupName": "1st Lactation",
      "calvingEase": null,
      "daysInPregnancy": 266,
      "oldLactationNumber": 0,
      "newborns": null,
      "type": "calving",
      "cowId": 924,
      "animalId": "975",
      "eventId": 34650,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 0,
      "ageInDays": 724,
      "startDateTime": 1514419200,
      "reportingDateTime": 1514620369
    },
    {
      "destinationGroup": 0,
      "destinationGroupName": null,
      "cowEntryStatus": "Heifer",
      "type": "herdEntry",
      "cowId": 1227,
      "animalId": "368",
      "eventId": 34642,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 0,
      "ageInDays": 0,
      "startDateTime": 1514419200,
      "reportingDateTime": 1514620353
    },
    {
      "birthDateCalculated": false,
      "type": "birth",
      "cowId": 1227,
      "animalId": "368",
      "eventId": 34640,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 0,
      "ageInDays": 0,
      "startDateTime": 1514419200,
      "reportingDateTime": 1514620353
    },
    {
      "healthIndex": 85,
      "endDate": 1514422800,
      "minValueDateTime": 1514415600,
      "type": "systemHealth",
      "cowId": 766,
      "animalId": "817",
      "eventId": 34620,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 165,
      "ageInDays": 1295,
      "startDateTime": 1514415600,
      "reportingDateTime": 1514423733
    },
    {
      "newGroupId": 57,
      "newGroupName": "Low",
      "currentGroupId": 60,
      "currentGroupName": "Calving Preparation",
      "type": "changeGroup",
      "cowId": 725,
      "animalId": "762",
      "eventId": 34675,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 358,
      "ageInDays": 1488,
      "startDateTime": 1514412000,
      "reportingDateTime": 1514749000
    },
    {
      "newGroupId": 59,
      "newGroupName": "1st Lactation",
      "currentGroupId": 61,
      "currentGroupName": "Prepare Heifers",
      "type": "changeGroup",
      "cowId": 924,
      "animalId": "975",
      "eventId": 34648,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 724,
      "ageInDays": 724,
      "startDateTime": 1514412000,
      "reportingDateTime": 1514620367
    },
    {
      "newGroupId": 41,
      "newGroupName": "Weaned Heifers",
      "currentGroupId": 46,
      "currentGroupName": "Suckling Calves",
      "type": "changeGroup",
      "cowId": 1196,
      "animalId": "338",
      "eventId": 34647,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 64,
      "ageInDays": 64,
      "startDateTime": 1514412000,
      "reportingDateTime": 1514620366
    },
    {
      "newGroupId": 41,
      "newGroupName": "Weaned Heifers",
      "currentGroupId": 46,
      "currentGroupName": "Suckling Calves",
      "type": "changeGroup",
      "cowId": 1195,
      "animalId": "337",
      "eventId": 34646,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 68,
      "ageInDays": 68,
      "startDateTime": 1514412000,
      "reportingDateTime": 1514620365
    },
    {
      "newGroupId": 41,
      "newGroupName": "Weaned Heifers",
      "currentGroupId": 46,
      "currentGroupName": "Suckling Calves",
      "type": "changeGroup",
      "cowId": 1194,
      "animalId": "336",
      "eventId": 34645,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 70,
      "ageInDays": 70,
      "startDateTime": 1514412000,
      "reportingDateTime": 1514620363
    },
    {
      "newGroupId": 59,
      "newGroupName": "1st Lactation",
      "currentGroupId": 61,
      "currentGroupName": "Prepare Heifers",
      "type": "changeGroup",
      "cowId": 903,
      "animalId": "954",
      "eventId": 34644,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 808,
      "ageInDays": 808,
      "startDateTime": 1514412000,
      "reportingDateTime": 1514620362
    },
    {
      "newGroupId": 58,
      "newGroupName": "Young",
      "currentGroupId": 61,
      "currentGroupName": "Prepare Heifers",
      "type": "changeGroup",
      "cowId": 931,
      "animalId": "982",
      "eventId": 34643,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 709,
      "ageInDays": 709,
      "startDateTime": 1514412000,
      "reportingDateTime": 1514620360
    },
    {
      "heatIndexPeak": "99",
      "type": "systemHeat",
      "cowId": 640,
      "animalId": "635",
      "eventId": 34623,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 86,
      "ageInDays": 2019,
      "startDateTime": 1514408400,
      "reportingDateTime": 1514445336
    },
    {
      "alertType": "postCalving",
      "duration": 1360,
      "originalStartDateTime": null,
      "endDateTime": 1514394648,
      "daysInPregnancy": null,
      "type": "distress",
      "cowId": 705,
      "animalId": "732",
      "eventId": 34618,
      "deletable": false,
      "lactationNumber": 3,
      "daysInLactation": 1,
      "ageInDays": 1600,
      "startDateTime": 1514391048,
      "reportingDateTime": 1514394723
    },
    {
      "heatIndexPeak": "78",
      "type": "systemHeat",
      "cowId": 608,
      "animalId": "560",
      "eventId": 34622,
      "deletable": false,
      "lactationNumber": 4,
      "daysInLactation": 438,
      "ageInDays": 2331,
      "startDateTime": 1514390400,
      "reportingDateTime": 1514427339
    },
    {
      "heatIndexPeak": "93",
      "type": "systemHeat",
      "cowId": 618,
      "animalId": "582",
      "eventId": 34621,
      "deletable": false,
      "lactationNumber": 5,
      "daysInLactation": 52,
      "ageInDays": 2262,
      "startDateTime": 1514383200,
      "reportingDateTime": 1514492722
    },
    {
      "healthIndex": 85,
      "endDate": 1514383200,
      "minValueDateTime": 1514365200,
      "type": "systemHealth",
      "cowId": 924,
      "animalId": "975",
      "eventId": 34607,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 723,
      "ageInDays": 723,
      "startDateTime": 1514365200,
      "reportingDateTime": 1514384125
    },
    {
      "healthIndex": 85,
      "endDate": 1514386800,
      "minValueDateTime": 1514365200,
      "type": "systemHealth",
      "cowId": 870,
      "animalId": "917",
      "eventId": 34606,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 234,
      "ageInDays": 897,
      "startDateTime": 1514365200,
      "reportingDateTime": 1514390104
    },
    {
      "heatIndexPeak": "64",
      "type": "systemHeat",
      "cowId": 920,
      "animalId": "971",
      "eventId": 34619,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 16,
      "ageInDays": 728,
      "startDateTime": 1514354400,
      "reportingDateTime": 1514393705
    },
    {
      "heatIndexPeak": "56",
      "type": "systemHeat",
      "cowId": 760,
      "animalId": "811",
      "eventId": 34608,
      "deletable": false,
      "lactationNumber": 2,
      "daysInLactation": 96,
      "ageInDays": 1321,
      "startDateTime": 1514336400,
      "reportingDateTime": 1514372715
    },
    {
      "healthIndex": 79,
      "endDate": 1514394000,
      "minValueDateTime": 1514365200,
      "type": "systemHealth",
      "cowId": 915,
      "animalId": "966",
      "eventId": 34530,
      "deletable": false,
      "lactationNumber": 1,
      "daysInLactation": 12,
      "ageInDays": 747,
      "startDateTime": 1514329200,
      "reportingDateTime": 1514395521
    },
    {
      "newGroupId": 61,
      "newGroupName": "Prepare Heifers",
      "currentGroupId": 66,
      "currentGroupName": "Heifers Pregnant",
      "type": "changeGroup",
      "cowId": 947,
      "animalId": "103",
      "eventId": 34617,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 676,
      "ageInDays": 676,
      "startDateTime": 1514325600,
      "reportingDateTime": 1514389085
    },
    {
      "newGroupId": 61,
      "newGroupName": "Prepare Heifers",
      "currentGroupId": 66,
      "currentGroupName": "Heifers Pregnant",
      "type": "changeGroup",
      "cowId": 929,
      "animalId": "980",
      "eventId": 34616,
      "deletable": false,
      "lactationNumber": 0,
      "daysInLactation": 713,
      "ageInDays": 713,
      "startDateTime": 1514325600,
      "reportingDateTime": 1514389084
    }
  ]

@Injectable()
export class FakeserverInterceptor implements HttpInterceptor {

  constructor() {}

  intercept(request: HttpRequest<unknown>, next: HttpHandler): Observable<HttpEvent<any>> {
    let mockData: any[] = JSON.parse(localStorage.getItem('mockData')|| JSON.stringify(mockdata)) || mockdata;

    // get all cows list
    if(request.method === "GET" && request.url === "http://localhost:4200/api/cows") {
          return of(new HttpResponse({ status: 200, body: mockData }));
     }

    // create new cow
    if ( request.url === "http://localhost:4200/api/create/cow" && request.method === 'POST') {
      // get new cow object from post body
      let newCow: any = request.body;

      // validation
      let duplicateAnimal = mockData.filter(cow => { return cow.cowId === newCow.cowId; }).length;
      if (duplicateAnimal) {
          return of(new HttpResponse({status: 401, body:'Username "' + newCow.cowId + '" is already taken'}));
      }

      // save new cow
      newCow.cowId = mockdata.length + 1;
      mockData.push(newCow);
      localStorage.setItem('mockData', JSON.stringify(mockData));

      // respond 200 and newCow
      return of(new HttpResponse({ status: 200, body: newCow}));
    }

    // get by cowid
    if(request.url.match(/\/api\/getbyId\/\d+$/) && request.method === 'GET') {
      let urlParts = request.url.split('/');
      let id = parseInt(urlParts[urlParts.length - 1]);
      let cowInfo
      for (let i = 0; i < mockData.length; i++) {
        let cow = mockData[i];
        if (cow.eventId === id) {
            cowInfo = cow
            break;
        }
    }

    // respond 200 OK
    return of(new HttpResponse({ status: 200, body: cowInfo}));
    }

    // update cow
    if ( request.url === "http://localhost:4200/api/update/cow" && request.method === 'POST') {
      // get new cow object from post body
      let updatedCow: any = request.body;
      let cowId = updatedCow.cowId

      for (let i = 0; i < mockData.length; i++) {
        if (cowId === mockData[i].cowId) {
            // update
            mockData[i] = updatedCow
            localStorage.setItem('mockData', JSON.stringify(mockData));
            break;
        }
      }
      // respond 200 and newCow
      return of(new HttpResponse({ status: 200, body: updatedCow}));
    }

    // delete cow
    if(request.url.match(/\/api\/delete\/\d+$/) && request.method === 'DELETE') {
      let urlParts = request.url.split('/');
      let id = parseInt(urlParts[urlParts.length - 1]);
      console.log(id)
      for (let i = 0; i < mockData.length; i++) {
        let cow = mockData[i];
        if (cow.eventId === id) {
            // delete
            mockData.splice(i, 1);
            localStorage.setItem('mockData', JSON.stringify(mockData));
            break;
        }
    }

    // respond 200 OK
    return of(new HttpResponse({ status: 200, body: mockData}));
    }

    return next.handle(request);
  }
}
